//
//  SelfiePresenter.swift
//  FADModulePhoto
//
//  Created by Juan Carlos Pérez on 1/25/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol SelfiePresentationLogic
{
    func presentInitialConfigResult(response: Selfie.Camera.Session)
    func presentCameraSession(response: Selfie.Camera.Session)
    func presentTakeSelfieAgain()
    func presentSetupCameraSessionResult(response: Selfie.Camera.Session)
    func presentProcessSmileResult(response : Selfie.SmileDetector.Response)
    func presentProcessSmileResult(response : Selfie.BlinkDetector.Response)
    func presentSwitchedCamera(response: Selfie.Camera.Session)
    func presentProcessBufferToPhoto(response: Selfie.Photo.Response)
}

class SelfiePresenter: SelfiePresentationLogic
{
   
    
    
  weak var viewController: SelfieDisplayLogic?
  

  
    func presentInitialConfigResult(response: Selfie.Camera.Session){
        
        var viewModel = Selfie.Config.ViewModel()
        viewModel.companyDynamicImage = Utils.getCompanyDynamicImage()
        viewModel.isProofLifeSelfie = Constants.isProofLifeSelfie
        
        viewModel.camSession = response.camSession
        viewModel.frontCameraDevice = response.frontCameraDevice
        
        
        viewController?.displayInitialConfigResult(viewModel: viewModel)
        viewController?.displayCameraSession(response: viewModel)
        viewController?.startViewSession()
        viewController?.startSessionRecognition()
        viewController?.generateRandomProofOfLife()
        viewController?.endInitialConfigResult()
    }
    
    
    func presentCameraSession(response: Selfie.Camera.Session) {
        var viewModel = Selfie.Config.ViewModel()
        viewModel.camSession = response.camSession
        viewModel.frontCameraDevice = response.frontCameraDevice
        
        viewController?.displayCameraSession(response: viewModel)
    }
    
    
    func presentTakeSelfieAgain() {
        viewController?.takeSelfieAgain()
        viewController?.generateRandomProofOfLife()
    }
    
    func presentSetupCameraSessionResult(response: Selfie.Camera.Session) {
        var viewModel = Selfie.Config.ViewModel()
        viewModel.videoOutput = response.videoOutput
        viewController?.displaySetupCameraSessionResult(response: viewModel)
    }
    
    func presentSwitchedCamera(response: Selfie.Camera.Session) {
        var viewModel = Selfie.Config.ViewModel()
        viewModel.camSession = response.camSession
        viewModel.frontCameraDevice = response.frontCameraDevice
        
        viewController?.displayCameraSession(response: viewModel)
    }
    
    
    func presentProcessSmileResult(response: Selfie.SmileDetector.Response) {
        var viewModel = Selfie.SmileDetector.ViewModel()
        viewModel.smileResult = response.smileResult
        viewModel.glassesTimeStamps = response.glassesTimeStamps
        
        switch response.smileResult {
        case 0, 1, 2, 3:
            viewController?.updateSmileStatus(viewModel: viewModel)
            break
        case 4:
            viewController?.updateProofIndex()
            break
        default:
            break
        }
    }
    
    
    func presentProcessSmileResult(response: Selfie.BlinkDetector.Response) {
        var viewModel = Selfie.BlinkDetector.ViewModel()
        
        viewModel.blinkResult = response.blinkResult
        viewModel.glassesTimeStamps = response.glassesTimeStamps
        
        switch response.blinkResult {
        case 0, 1, 2, 3:
            viewController?.updateBlinkStatus(viewModel: viewModel)
            break
        case 4:
            viewController?.updateProofIndex()
            break
        default:
            break
        }
    }
    
    
    func presentProcessBufferToPhoto(response: Selfie.Photo.Response) {
        let viewModel = Selfie.Photo.ViewModel(success: response.success, imgPhoto: response.imgPhoto, timeToTakeSelfie: response.timeToTakeSelfie)
        viewController?.displayProcessBufferToPhoto(viewModel: viewModel)
    }
    
}
